
/*
   wmch : A Window Manager CHooser
   Copyright (C) 1997  Dominique Rousseau <rousseau@neuronnexion.fr>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

   Parts from GUBI are Copyright (C) Tim Janik  <timj@psynet.net>
 */

#include	"exec.h"

/* Event functions */

#include <unistd.h>
#include <string.h>

#include <glib.h>

void dispatch_cmd(char *cmd, char ***argv, int *argc)
{
	int c;
	char **v;
	char *s;
	int is_space;
	int i;

	s = cmd;
	c = 1;
	while (*s) {
		/* Search space */
		switch (*s) {
		case ' ':
			/* Search end of spaces */
			c++;
			s++;
			is_space = 1;
			while (is_space) {
				switch (*s) {
				case ' ':
					s++;
					break;

				default:
					is_space = 0;
					break;
				}
			}
			break;

		default:
			s++;
			break;
		}
	}

	v = g_new(char *, c);
	v[0] = strtok(cmd, " ");
	for (i = 1; (v[i] = strtok(NULL, " \0")); i++);

	*argv = v;
	*argc = i;
}
